You can not select more than 25 topics
Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
95 lines
3.0 KiB
95 lines
3.0 KiB
7 years ago
|
From 166491bd870df6877e04831c9da593e2f8e77ca8 Mon Sep 17 00:00:00 2001
|
||
|
From: "Brian C. Lane" <bcl@redhat.com>
|
||
|
Date: Thu, 19 Apr 2012 17:11:09 -0700
|
||
|
Subject: [PATCH] tests: test creating 20 device-mapper partitions (#803108)
|
||
|
|
||
|
* tests/t6002-dm-many-partitions.sh: Make sure > 17 partitions appear in
|
||
|
device mapper.
|
||
|
---
|
||
|
tests/Makefile.am | 1 +
|
||
|
tests/t6002-dm-many-partitions.sh | 60 +++++++++++++++++++++++++++++++++++++
|
||
|
2 files changed, 61 insertions(+), 0 deletions(-)
|
||
|
create mode 100755 tests/t6002-dm-many-partitions.sh
|
||
|
|
||
|
diff --git a/tests/Makefile.am b/tests/Makefile.am
|
||
|
index 1b37fd9..57771be 100644
|
||
|
--- a/tests/Makefile.am
|
||
|
+++ b/tests/Makefile.am
|
||
|
@@ -55,6 +55,7 @@ TESTS = \
|
||
|
t5000-tags.sh \
|
||
|
t6000-dm.sh \
|
||
|
t6001-psep.sh \
|
||
|
+ t6002-dm-many-partitions.sh \
|
||
|
t6100-mdraid-partitions.sh \
|
||
|
t7000-scripting.sh \
|
||
|
t8000-loop.sh \
|
||
|
diff --git a/tests/t6002-dm-many-partitions.sh b/tests/t6002-dm-many-partitions.sh
|
||
|
new file mode 100755
|
||
|
index 0000000..4d08e72
|
||
|
--- /dev/null
|
||
|
+++ b/tests/t6002-dm-many-partitions.sh
|
||
|
@@ -0,0 +1,60 @@
|
||
|
+#!/bin/sh
|
||
|
+# device-mapper: create many partitions
|
||
|
+# This would not create partitions > 16 when using device-mapper
|
||
|
+
|
||
|
+# Copyright (C) 2012 Free Software Foundation, Inc.
|
||
|
+
|
||
|
+# This program is free software; you can redistribute it and/or modify
|
||
|
+# it under the terms of the GNU General Public License as published by
|
||
|
+# the Free Software Foundation; either version 3 of the License, or
|
||
|
+# (at your option) any later version.
|
||
|
+
|
||
|
+# This program is distributed in the hope that it will be useful,
|
||
|
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
|
||
|
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
|
||
|
+# GNU General Public License for more details.
|
||
|
+
|
||
|
+# You should have received a copy of the GNU General Public License
|
||
|
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
|
||
|
+
|
||
|
+. "${srcdir=.}/init.sh"; path_prepend_ ../parted
|
||
|
+
|
||
|
+require_root_
|
||
|
+(dmsetup --help) > /dev/null 2>&1 || skip_test_ "No dmsetup installed"
|
||
|
+
|
||
|
+ss=$sector_size_
|
||
|
+ns=300
|
||
|
+n_partitions=20
|
||
|
+start_sector=34
|
||
|
+loop_file=loop-file-$$
|
||
|
+dm_name=dm-test-$$
|
||
|
+
|
||
|
+cleanup_() {
|
||
|
+ dmsetup remove $dm_name
|
||
|
+ test -n "$dev" && losetup -d "$dev"
|
||
|
+ rm -f $loop_file;
|
||
|
+}
|
||
|
+
|
||
|
+# create a file large enough to hold a GPT partition table
|
||
|
+dd if=/dev/null of=$loop_file bs=$ss seek=$ns || framework_failure
|
||
|
+dev=$(losetup --show -f $loop_file) || framework_failure
|
||
|
+dmsetup create $dm_name --table "0 $ns linear $dev 0" || framework_failure
|
||
|
+
|
||
|
+cmd=
|
||
|
+for ((i=1; i<=$n_partitions; i+=1)); do
|
||
|
+ s=$((start_sector + i - 1))
|
||
|
+ cmd="$cmd mkpart p$i ${s}s ${s}s"
|
||
|
+done
|
||
|
+parted -m -a min -s /dev/mapper/$dm_name mklabel gpt $cmd > /dev/null 2>&1 || fail=1
|
||
|
+
|
||
|
+# Make sure all the partitions appeared under /dev/mapper/
|
||
|
+for ((i=1; i<=$n_partitions; i+=1)); do
|
||
|
+ if [ ! -e "/dev/mapper/${dm_name}p$i" ]; then
|
||
|
+ fail=1
|
||
|
+ break
|
||
|
+ fi
|
||
|
+ # remove the partitions as we go, otherwise cleanup won't work.
|
||
|
+ dmsetup remove /dev/mapper/${dm_name}p$i
|
||
|
+done
|
||
|
+
|
||
|
+Exit $fail
|
||
|
--
|
||
|
1.7.7.6
|
||
|
|